
TYPO3.Fluid - Task # 9214

Task # 26664 (New): Clean up Form ViewHelpers
Task # 26658 (New): Make Form ViewHelpers consistent

Status: Closed Priority: Must have
Author: Bastian Waidelich Category: ViewHelpers
Created: 2010-08-09 Assigned To: Bastian Waidelich
Updated: 2012-05-08 Due date:
Has patch: No
Subject: Improve handling of bound properties in checkbox, radio and select ViewHelpers
Description

Currently the behavior for form.checkbox, form.radio & form.select ViewHelpers is not clear and leads to errors when bound to
objects. See #8854 for example.

We'll have to define, what output is expected in which case to be able to properly refactor these ViewHelpers.

Related issues:
related to TYPO3.Fluid - Task # 5636: Form_RadioViewHelper and CheckBoxViewHe... Under Review 2009-12-05
related to TYPO3.Fluid - Bug # 8854: form.checkbox ViewHelper throws Exceptio... Resolved 2010-07-14

History
#1 - 2010-08-09 14:51 - Bastian Waidelich
- File given_v1.png added
- File form.checkbox_v1.png added
- File form.radio_v1.png added

Attached is a first version of an input-output-matrix for checkbox and radio ViewHelpers. A sheet for select ViewHelper follows.

Feel free to comment

#2 - 2010-08-09 15:32 - Bastian Waidelich
- File given_v2.png added
- File form.checkbox_v2.png added
- File form.radio_v2.png added

Added examples for properties of type string/integer after discussion with Michael Feinbier.

#3 - 2010-08-09 20:01 - Bastian Waidelich
- File deleted (given_v1.png)

#4 - 2010-08-09 20:01 - Bastian Waidelich
- File deleted (form.checkbox_v1.png)

#5 - 2010-08-09 20:01 - Bastian Waidelich
- File deleted (form.radio_v1.png)

#6 - 2010-08-09 20:01 - Bastian Waidelich
- File deleted (given_v2.png)

#7 - 2010-08-09 20:01 - Bastian Waidelich
- File deleted (form.checkbox_v2.png)

#8 - 2010-08-09 20:01 - Bastian Waidelich
- File deleted (form.radio_v2.png)

#9 - 2010-08-09 20:03 - Bastian Waidelich
- File given_v3.png added
- File form.checkbox_v3.png added
- File form.radio_v3.png added
- File form.select_v3.png added
- File 9214_improve_checkbox_radio_and_select_viewhelpers.xlsx added

Updated version of the input-output matrices and the corresponding Excel file

#10 - 2010-08-10 11:12 - Michael Feinbier
- File 9214_improve_checkbox_radio_and_select_viewhelpers_mf.xls added

Hey

thanks for your work on this :)
I think you missed the value-attribute in the form.select matrix. The combination of both value and option is important for the behaviour of this
viewHelper.
I updated your Excel-sheet in the select-tab. I did the matrix for "tags" and "hidden" already. If I find some additional time today I will do the rest oft it.

#11 - 2011-02-03 18:19 - Peter Niederlag

any updates on this? can we help out somehow?

#12 - 2011-02-03 18:23 - Michael Feinbier

Hey Peter,

I started to work on this some days ago. Would be nice if you have a look at the matrix and see, if you miss something

#13 - 2011-02-03 18:46 - Bastian Waidelich
- Priority changed from Should have to Must have

Michael Feinbier wrote:

I started to work on this some days ago.

That's great. This seems to be one of the burning issues!
#14 - 2011-05-06 10:03 - Sebastian Kurfuerst
- Target version set to 1.0 beta 2
- Parent task set to #26658

#15 - 2011-07-28 16:46 - Christopher Seidel

Hi,

i hope this is okay for you but i had problems with the checkbox Viewhelper and ObjectStorages. I wasnt able to bind an ObjectStorage to a checkbox
but i made a small solution to fix this problem.

Old code:

} elseif (is_array($propertyValue)) {
                $checked = in_array($valueAttribute, $propertyValue);
                $nameAttribute .= '[]';
            } else {
                throw new Tx_Fluid_Core_ViewHelper_Exception('Checkbox viewhelpers can only be bound to properties of type boolean or array.
Property "' . $this->arguments['property'] . '" is of type "' . (is_object($propertyValue) ? get_class($propertyValue) : gettype($propertyValue)) .
'".' , 1248261038);
            }

New Code with added the elseif

} elseif (is_array($propertyValue)) {
                            $checked = in_array($valueAttribute, $propertyValue);
                            $nameAttribute .= '[]';
                    } elseif(is_object($propertyValue)) {
                            foreach ($propertyValue as $value) {
                                if($valueAttribute == $value->getUid()) {
                                    $checked = $value->getUid();
                                }
                            }
                            $nameAttribute .= '[]';
                    } else {
                            throw new Tx_Fluid_Core_ViewHelper_Exception('Checkbox viewhelpers can only be bound to properties of type boolean or
array. Property "' . $this->arguments['property'] . '" is of type "' . (is_object($propertyValue) ? get_class($propertyValue) :
gettype($propertyValue)) . '".' , 1248261038);
                    }

#16 - 2011-09-09 15:20 - Robert Lemke
- Target version changed from 1.0 beta 2 to 1.0.0

#17 - 2011-10-20 01:48 - Karsten Dambekalns
- Target version deleted (1.0.0)

#18 - 2012-05-08 18:09 - Bastian Waidelich
- Status changed from Accepted to Closed
- Has patch set to No

Most of this has been resolved in the meantime and the Form framework shows that the Form ViewHelpers work in fact. There are still some glitches,
but we should tackle them in smaller change sets.

Files
given_v3.png 15 kB 2010-08-09 Bastian Waidelich
form.checkbox_v3.png 29.7 kB 2010-08-09 Bastian Waidelich
form.radio_v3.png 29.9 kB 2010-08-09 Bastian Waidelich
form.select_v3.png 77.7 kB 2010-08-09 Bastian Waidelich
2015-08-03 4/4


